

void main() {
  // #ФУНКЦИИ
  
  // Функция представляет собой блок кода, который выполняет определенные операции и может возвращать значения. 
  // Функции являются основным строительным блоком программирования в Dart и используются для организации и структурирования кода.

  void functionValue(value){
    print(value);

  }
  functionValue(123); // выведет результат значения функции functionValue

  var list =[1,2,3];
  //list.forEach(functionValue); // вывел лист в отдельные числа
   
  list.forEach((value){
    print(value);
  });
  // если тело функции состоит из одного выражения то можно использовать стрелочные функции. Пример:

  list.forEach((value) => print(value));

  // так же в функцию можно передать переменную. Выглядеть это будет вот так:

  var toUp = (value) => "${value.toUpperCase()}";
  print(toUp('This is Dart'));
  // #Параметры функции.
  // Функции в Dart могут принимать параметры, которые передаются им при вызове. Вот пример функции с параметрами:
  void greetPerson(String name) {
    print('Привет ${name}!');
  }
  greetPerson('Вадим');
   
  // #Именнованные параметры (named parameters)
  // Именнованные параметры в Dart предоставляют возможность определить параметры функции, которые могут быть переданы по
  // имени вместо позиции, что делает вызов функции более читабельным и гибким.

  // Именнованные параметры указываются в фигурных скобках {}, после которых идет двоеточие : и тип данных параметра. 
  // Вот пример объявления функции с именнованными параметрами:

  void greatPerson( { String? name, int? age} ) {
    print('Привет, ${name}! Тебе ${age} года.');
  }
  greatPerson( age: 33, name: 'VOLODYA'); // от перестановки именных параметров ничего не должно меняться так как параметры при вызове имеют названия

  // #Позиционные параметры 
  // Позиционные параметры (positional parameters) в Dart представляют собой параметры функции, которые передаются по позиции, 
  // т.е. соответственно порядку, в котором они объявлены в списке параметров функции.

  // Позиционные параметры объявляются в списке параметров функции без использования символов фигурных скобок {} или символов равенства =
  // Вот пример объявления функции с позиционными параметрами:

  String Person(String? name, int? age, [int? inn]) { // [int? inn] - это не обязательный параметр функции
    var result = 'Привет, ${name}! Тебе ${age} лет';
    if(inn != null){
      result = '$result (ИНН: ${inn}).';
    }

    return result;
  }
  print(Person('NAme', 33, 4895730575)); // вот тут перестановка влияет так как(писал выше) при вызове функции, параметры указаны без наименования

  // #Параметры по умолчанию 
  // Параметры со значением по умолчанию (Default Value Parameters):
  // Это параметры, которые имеют предустановленные значения. 
  // Если значение для такого параметра не указано при вызове функции, будет использовано значение по умолчанию. 
  // Они объявляются в списке параметров функции с использованием символа равенства =
  // Пример:

  void defVal(String name, [int age = 18]) {
    print('Привет, $name! Тебе $age лет.');
  }
  defVal('Na,e' ); // Выведет "Привет, Na,e! Тебе 18 лет.", но если вторым параметром указать число ты выведет количество лет другое.
  
  
  // #Обязательные параметры. 
  // Обязательные параметры (Required Parameters): Это параметры, для которых значение должно быть указано при вызове функции. 
  // Они объявляются в списке параметров без использования символа равенства = или указания значения по умолчанию.
  // Пример:

  void reqVal({required String? name, int? age}) {
    print('Привет, $name! Тебе $age лет.');
  }
  reqVal(name: 'Alisa', age: 13 );

  
}
